import 'package:mason/mason.dart';
import 'package:mvp_cli/src/templates/templates.dart';
import 'package:universal_io/io.dart';

/// {@template mvp_core_template}
/// A core Flutter app template.
/// {@endtemplate}
class MvpCoreTemplate extends Template {
  /// {@macro mvp_core_template}
  MvpCoreTemplate()
      : super(
          name: 'core',
          bundle: mvpCoreBundle,
          help: 'Generate an MVP Flutter application.',
        );

  @override
  Future<void> onGenerateComplete(Logger logger, Directory outputDir) async {
    await installFlutterPackages(logger, outputDir);
    await applyDartFixes(logger, outputDir);
    _logSummary(logger);
  }

  void _logSummary(Logger logger) {
    logger
      ..info('\n')
      ..alert('Created a MVP App! 🚀')
      ..info('\n')
      ..info(
        lightGray.wrap(
          '''
+----------------------------------------------------+
| New features Coming Soon?                         |
|                                                   |
+----------------------------------------------------+''',
        ),
      );
  }
}
